#ifndef MHPDBG_H
#define MHPDBG_H

#define VM86_TRAP 4	  /* (vm86 return) TRAP */

#define DBG_INIT 0
#define DBG_INTx 1
#define DBG_TRAP 2
#define DBG_POLL 3
#define DBG_GPF  4

unsigned int mhp_debug(unsigned int, unsigned int, unsigned int);

#ifdef MHP_PRIVATE

#define DBG_TYPE(val)	       ((val) & 0xff)
#define DBG_ARG(val)	       ((val) >> 8)
#define SRSIZE 8192
#define MYPORT 3456
#define IBUFS 100
#define MAXARG 16
#define MAXBP 64
#define MAXSYM 3500

void mhp_printf(const char *,...);
void mhp_cmd(const char *);
void mhp_bpset(void);
void mhp_bpclr(void);
int  mhp_bpchk(unsigned char *);

struct brkentry {
   unsigned char * brkaddr;
   unsigned char opcode;
};

struct cmd_db {
   char cmdname[12];
   void (*cmdproc)(int, char *[]);
};

struct mhpdbg
{
   unsigned char sendbuf[SRSIZE];
   unsigned char recvbuf[SRSIZE];
   int sendptr;

   int socketd;
   int usocketd;
   struct sockaddr_in sa_server;
   struct sockaddr sa_client;
};

struct mhpdbgc
{
   int stopped;
   int currcode;
   int trapcmd;
   char intxxtab[256];
   struct brkentry brktab[MAXBP];
};

struct symbol_entry {
   unsigned int  addr;
   unsigned char type;
   unsigned char name[49];
};

struct symbl2_entry {
   unsigned short seg;
   unsigned short off;
   unsigned char type;
   unsigned char name[49];
};
#endif	 /* MHP_PRIVATE */
#endif	 /* MHPDBG_H */
